const
  nw_netwareCalls  = 'NWCALLS.DLL'   ;  { Netware DLL FileNames }
  nw_NDSCalls      = 'NWNET.DLL'     ;
  nw_localeCalls   = 'NWLOCALE.DLL'  ;

  nw_badObject     = $0000 ;           { Object Types }
  nw_user          = $0100 ;
  nw_group         = $0200 ;
  nw_printq        = $0300 ;
  nw_server        = $0400 ;
  nw_jobServer     = $0500 ;
  nw_gateway       = $0600 ;
  nw_printServer   = $0700 ;
  nw_archiveQueue  = $0800 ;
  nw_archiveServer = $0900 ;
  nw_jobQueue      = $0A00 ;
  nw_Administration= $0B00 ;
  nw_nasSNAServer  = $2100 ;
  nw_RemoteBridge  = $2600 ;
  nw_TCPIPGateway  = $2700 ;
  nw_castOn        = 0   ;             { Broadcast Modes }
  nw_castOff       = $01 ;
  nw_castOffAll    = $02 ;
  nw_castPoll      = $03 ;
  nw_format_netware       = 0   ;      { Returned Path Formats } 
  nw_format_server_volume = $01 ;
  nw_format_drive         = $02 ;
  nw_format_unc           = $03 ;

  { Internal Definitions }
  word_local              = 'Local'   ;
  word_unknown            = 'Unknown' ;
  word_none               = 'None'    ;

  { Bindery Types }
  type_set                = $02 ;
  type_item               = 0   ;

  { netware file open modes }
  nw_file_normal          = 0   ;
  nw_file_readOnly        = $01 ;
  nw_file_hidden          = $02 ;
  nw_file_system          = $04 ;
  nw_file_execute_only    = $08 ;
  nw_file_directory       = $10 ;
  nw_file_needsArchived   = $20 ;
  nw_file_shareable       = $80 ;

  { nds context keys }
  nds_key_flags           = $01 ;
  nds_key_confidence      = $02 ;
  nds_key_contextname     = $03 ;
  nds_key_transportType   = $04 ;
  nds_key_referralScope   = $05 ;

  nds_read                = 3  ;
  nds_compare             = 4  ;
  nds_search              = 6  ;
  nds_add_entry           = 7  ;
  nds_modify_entry        = 9  ;
  nds_read_attr_def       = 12 ;
  nds_define_class        = 14 ;
  nds_read_class_def      = 15 ;
  nds_modify_class_def    = 16 ;
  nds_search_filter       = 28 ;

  nds_add_attribute       = $00 ;
  nds_remove_attribute    = $01 ;
  nds_add_value           = $02 ;
  nds_remove_value        = $03 ;

  nds_entry_browse        = $0001 ;
  nds_entry_add           = $0002 ;
  nds_entry_delete        = $0004 ;
  nds_entry_rename        = $0008 ;
  nds_entry_supervisor    = $0010 ;

  nds_attr_compare        = $0001 ;
  nds_attr_read           = $0002 ;
  nds_attr_write          = $0004 ;
  nds_attr_self           = $0008 ;
  nds_attr_supervisor     = $0020 ;

  nds_sms_scan            = $0001 ;
  nds_sms_backup          = $0002 ;
  nds_sms_restore         = $0004 ;
  nds_sms_rename          = $0008 ;
  nds_sms_delete          = $0010 ;
  nds_sms_admin           = $0020 ;

  max_rdn_chars           = 127 ;
  max_dn_chars            = 254 ;
  max_schema_name_chars   = 31  ;
  max_rdn_bytes           = (2*(max_rdn_chars+1)) ;
  max_dn_bytes            = (2*(max_dn_chars+1)) ;
  max_schema_name_bytes   = (2*(max_schema_name_chars+1)) ;
  max_asn1_name           = 31;
  max_value               = (63 * 1024) ;
  max_message             = $10000 ;
  no_more_iterations      = -1 ; {0xffffffffl}

  ftok_end                = 0  ;
  ftok_or                 = 1  ;
  ftok_and                = 2  ;
  ftok_not                = 3  ;
  ftok_lparen             = 4  ;
  ftok_rparen             = 5  ;
  ftok_aval               = 6  ;
  ftok_eq                 = 7  ;
  ftok_ge                 = 8  ;
  ftok_le                 = 9  ;
  ftok_approx             = 10 ;
  ftok_aname              = 14 ;
  ftok_present            = 15 ;
  ftok_rdn                = 16 ;
  ftok_basecls            = 17 ;

  DSV_UNUSED_0	                 = 0  ;
  DSV_RESOLVE_NAME              = 1  ;
  DSV_READ_ENTRY_INFO           = 2  ;
  DSV_READ                      = 3  ;
  DSV_COMPARE                   = 4  ;
  DSV_LIST                      = 5  ;
  DSV_SEARCH                    = 6  ;
  DSV_ADD_ENTRY                 = 7  ;
  DSV_REMOVE_ENTRY              = 8  ;
  DSV_MODIFY_ENTRY              = 9  ;
  DSV_MODIFY_RDN                = 10 ;
  DSV_DEFINE_ATTR               = 11 ;
  DSV_READ_ATTR_DEF             = 12 ;
  DSV_REMOVE_ATTR_DEF           = 13 ;
  DSV_DEFINE_CLASS              = 14 ;
  DSV_READ_CLASS_DEF            = 15 ;
  DSV_MODIFY_CLASS_DEF          = 16 ;
  DSV_REMOVE_CLASS_DEF          = 17 ;
  DSV_LIST_CONTAINABLE_CLASSES  = 18 ;
  DSV_GET_EFFECTIVE_RIGHTS      = 19 ;
  DSV_ADD_PARTITION             = 20 ;
  DSV_REMOVE_PARTITION          = 21 ;
  DSV_LIST_PARTITIONS           = 22 ;
  DSV_SPLIT_PARTITION           = 23 ;
  DSV_JOIN_PARTITIONS           = 24 ;
  DSV_ADD_REPLICA               = 25 ;
  DSV_REMOVE_REPLICA            = 26 ;
  DSV_OPEN_STREAM               = 27 ;
  DSV_SEARCH_FILTER             = 28 ;
  DSV_CREATE_SUBORDINATE_REF    = 29 ;
  DSV_LINK_REPLICA              = 30 ;
  DSV_CHANGE_REPLICA_TYPE       = 31 ;
  DSV_START_UPDATE_SCHEMA       = 32 ;
  DSV_END_UPDATE_SCHEMA         = 33 ;
  DSV_UPDATE_SCHEMA             = 34 ;
  DSV_START_UPDATE_REPLICA      = 35 ;
  DSV_END_UPDATE_REPLICA        = 36 ;
  DSV_UPDATE_REPLICA            = 37 ;
  DSV_SYNC_PARTITION            = 38 ;
  DSV_SYNC_SCHEMA               = 39 ;
  DSV_READ_SYNTAXES             = 40 ;
  DSV_GET_REPLICA_ROOT_ID       = 41 ;
  DSV_BEGIN_MOVE_ENTRY          = 42 ;
  DSV_FINISH_MOVE_ENTRY         = 43 ;
  DSV_RELEASE_MOVED_ENTRY       = 44 ;
  DSV_BACKUP_ENTRY              = 45 ;
  DSV_RESTORE_ENTRY             = 46 ;
  DSV_SAVE_DIB                  = 47 ;
  DSV_UNUSED_2                  = 48 ;
  DSV_UNUSED_3                  = 49 ;
  DSV_CLOSE_ITERATION           = 50 ;
  DSV_UNUSED_4                  = 51 ;
  DSV_AUDIT_SKULKING            = 52 ;
  DSV_GET_SERVER_ADDRESS        = 53 ;
  DSV_SET_KEYS                  = 54 ;
  DSV_CHANGE_PASSWORD           = 55 ;
  DSV_VERIFY_PASSWORD           = 56 ;
  DSV_BEGIN_LOGIN               = 57 ;
  DSV_FINISH_LOGIN              = 58 ;
  DSV_BEGIN_AUTHENTICATION      = 59 ;
  DSV_FINISH_AUTHENTICATION     = 60 ;
  DSV_LOGOUT                    = 61 ;
  DSV_REPAIR_RING               = 62 ;
  DSV_REPAIR_TIMESTAMPS         = 63 ;
  DSV_CREATE_BACKLINK           = 64 ;
  DSV_DELETE_EXTERNAL_REFERENCE = 65 ;
  DSV_RENAME_EXTERNAL_REFERENCE = 66 ;
  DSV_CREATE_ENTRY_DIR          = 67 ;
  DSV_REMOVE_ENTRY_DIR          = 68 ;
  DSV_DESIGNATE_NEW_MASTER      = 69 ;
  DSV_CHANGE_TREE_NAME          = 70 ;
  DSV_PARTITION_ENTRY_COUNT     = 71 ;
  DSV_CHECK_LOGIN_RESTRICTIONS  = 72 ;
  DSV_START_JOIN                = 73 ;
  DSV_LOW_LEVEL_SPLIT           = 74 ;
  DSV_LOW_LEVER_JOIN            = 75 ;
  DSV_ABORT_LOW_LEVEL_JOIN      = 76 ;
  DSV_GET_ALL_SERVERS           = 77 ;

  { Bindery Write Access Levels }
  BS_ANY_WRITE    = 0 ;
  BS_LOGGED_WRITE = $10 ;
  BS_OBJECT_WRITE = $20 ;
  BS_SUPER_WRITE  = $30 ;
  BS_BINDERY_WRITE= $40 ;

  { Bindery Read Access Levels }
  BS_ANY_READ     = 0 ;
  BS_LOGGED_READ  = $01 ;
  BS_OBJECT_READ  = $02 ;
  BS_SUPER_READ   = $03 ;
  BS_BINDERY_READ = $04 ;

  { Bindery Obj/Prop Flags }
  BF_STATIC       = 0   ;
  BF_DYNAMIC      = $01 ;
  BF_ITEM         = 0   ;
  BF_SET          = $02 ;

  { Trustee Rights Masks }
  TA_NONE         = $00  ;
  TA_READ         = $01  ;
  TA_WRITE        = $02  ;
  TA_OPEN         = $04  ;
  TA_CREATE       = $08  ;
  TA_DELETE       = $10  ;
  TA_OWNERSHIP    = $20  ;
  TA_SEARCH       = $40  ;
  TA_MODIFY       = $80  ;
  TA_ALL          = $A0  ;

  { Directory Inherited Rights Masks }
  TR_NONE         = $0000 ;
  TR_READ         = $0001 ;
  TR_WRITE        = $0002 ;
  TR_OPEN         = $0004 ;
  TR_CREATE       = $0008 ;
  TR_DELETE       = $0010 ;
  TR_OWNER        = $0010 ;
  TR_ACCESSCTRL   = $0020 ;
  TR_FILESCAN     = $0040 ;
  TR_MODIFY       = $0080 ;
  TR_ALL          = $01FB ;
  TR_SUPERVISOR   = $0100 ;
  TR_NORMAL       = $00FB ;

  {file attributes}
  fa_normal       = $00 ;
  fa_readOnly     = $01 ;
  fa_hidden       = $02 ;
  fa_system       = $04 ;
  fa_executeOnly  = $08 ;
  fa_directory    = $10 ;
  fa_needsArchive = $20 ;
  fa_shareable    = $80 ;
  fa_transaction  = $10 ;
  fa_indexed      = $20 ;
  fa_readAudit    = $40 ;
  fa_writeAudit   = $80 ;

  qms_auto_start    = $08 ;
  qms_entry_restart = $10 ;
  qms_entry_open    = $20 ;
  qms_user_hold     = $40 ;
  qms_operator_hold = $80 ;

  {drive status codes}
  NW_FREE_DRIVE         = $0000 ;
  NW_CDROM_DRIVE        = $0400 ;
  NW_LOCAL_FREE_DRIVE   = $0800 ;
  NW_LOCAL_DRIVE        = $1000 ;
  NW_NETWORK_DRIVE      = $2000 ;
  NW_PNW_DRIVE          = $4000 ;
  NW_NETWARE_DRIVE      = $8000 ;

  {print server connection modes}
  NWPS_BINDERY_SERVICE	 = 0 ;
  NWPS_DIRECTORY_SERVICE = 1 ;
  NWPS_BINDERY_SERVICE_PRE_40 = 2 ;
  

  {sdk api error codes}
  NWERROR_ALREADY_ATTACHED    = $8800 ;
  NWERROR_INVALID_CONNECTION  = $8801 ;

  {internal error mode constants (1.42+) }
  NWERR_none               = $0000 ;
  NWERR_nwcalls            = $0001 ;
  NWERR_nwnet              = $0002 ;
  NWERR_nwlocale           = $0003 ;
  NWERR_addToStringList    = $0011 ;
  NWERR_noMoreSearchDrives = $0012 ;
  NWERR_newSearchDrive     = $0013 ;

  {...}
  NWERR_unknown            = $FFFF ;



























